#include "mpi.h"

#include <print>

int wrapAround(int value, int size)
{
    if (value < 0)
        return size + value;
    if (value >= size)
        return value - size;
    return value;
}

int main(int argc, char* argv[])
{
    MPI_Init(&argc, &argv);
    int rank, size;
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    MPI_Comm_size(MPI_COMM_WORLD, &size);

    const int dest = wrapAround(rank + 1, size);
    const int src  = wrapAround(rank - 1, size);

    MPI_Request send_req, recv_req;

    MPI_Isend(&rank, 1, MPI_INT, dest, 0, MPI_COMM_WORLD, &send_req);
    int recvd_data;
    MPI_Irecv(&recvd_data, 1, MPI_INT, src, 0, MPI_COMM_WORLD, &recv_req);

    MPI_Wait(&recv_req, MPI_STATUS_IGNORE);

    std::println("Rank {} received {}", rank, recvd_data);
    MPI_Wait(&send_req, MPI_STATUS_IGNORE);
    MPI_Finalize();
}
